@echo off
cls
rem **********************************************************************
set hex1=BL652_MBR_SD_APP_magic_BLR_UICR
rem **********************************************************************

if not exist %hex1%.hex goto :nofile

set hex2=WormInfo
set app=%hex1%pWORM
set wrmstart=0x7D000
set wrmlen=4096

rem --------------------------------
rem  Read Licence
rem --------------------------------
echo ..                Acquiring info
nrfjprog -f NRF52 %2 %3 %4 %5 %6 %7 %8 %9  --memrd %wrmstart% --n %wrmlen% --w 8 >%hex2%.txt
if ERRORLEVEL 1 goto nrfjprog_err

rem --------------------------------
rem  Convert to hex file
rem --------------------------------
echo ...
Nrf2Hex %hex2%.txt /B %wrmlen% /I 1 >NUL
if ERRORLEVEL 1 goto nrf2Hex_err

rem --------------------------------
rem  Merge Hex file :
rem --------------------------------
echo ....
mergehex -q -m %hex1%.hex %hex2%.hex -o %app%.hex
if not exist %app%.hex goto merge_err

echo %TIME%       Time at program start

rem -----------------------------------
rem  Erase the entire chip
rem -----------------------------------
echo .                 Erasing chip (please wait)
nrfjprog -f NRF52 %2 %3 %4 %5 %6 %7 %8 %9 --eraseall --quiet
echo ..                Erasing chip (done)

rem -----------------------------------
rem  Write the file
rem -----------------------------------

echo ...               Programming hex file with worm (please wait)
nrfjprog -f NRF52 %2 %3 %4 %5 %6 %7 %8 %9 --clockspeed 10000 --program %app%.hex --reset --quiet
echo ....              Programming hex file with worm (done)

echo %TIME%       Time at program finish

rem -----------------------------------
rem  Delete all temporaty files
rem -----------------------------------
if exist %hex2%.txt del %hex2%.txt >NUL
if exist %hex2%.hex del %hex2%.hex >NUL
if exist %app%.hex  del %app%.hex  >NUL

rem **********************************************************************
echo ..................
echo ################################
echo The firmware upgrade is complete
echo ################################
echo .
rem **********************************************************************
goto :end

:merge_err
rem **********************************************************************
echo .
echo FAIL: Final merged hex file could not be created
echo .
rem **********************************************************************
goto :pauseend

:nrf2Hex_err
rem **********************************************************************
echo .
echo FAIL: Worm hex file could not be created by Nrf2Hex utility
echo .
rem **********************************************************************
goto :pauseend

:nrfjprog_err
rem **********************************************************************
echo .
echo FAIL: licence could not be read
echo .
rem **********************************************************************
goto :pauseend

:nofile
rem **********************************************************************
echo .
echo FAIL: %hex1%.hex is missing
echo .
rem **********************************************************************
goto :pauseend


:pauseend
if "%1" == "nopause" goto :end
pause
:end
